<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SelectUyeAdres StructType
 * @subpackage Structs
 */
class SelectUyeAdres extends AbstractStructBase
{
    /**
     * The UyeKodu
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UyeKodu;
    /**
     * The adresId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $adresId;
    /**
     * The uyeId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $uyeId;
    /**
     * Constructor method for SelectUyeAdres
     * @uses SelectUyeAdres::setUyeKodu()
     * @uses SelectUyeAdres::setAdresId()
     * @uses SelectUyeAdres::setUyeId()
     * @param string $uyeKodu
     * @param int $adresId
     * @param int $uyeId
     */
    public function __construct($uyeKodu = null, $adresId = null, $uyeId = null)
    {
        $this
            ->setUyeKodu($uyeKodu)
            ->setAdresId($adresId)
            ->setUyeId($uyeId);
    }
    /**
     * Get UyeKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUyeKodu()
    {
        return isset($this->UyeKodu) ? $this->UyeKodu : null;
    }
    /**
     * Set UyeKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uyeKodu
     * @return \StructType\SelectUyeAdres
     */
    public function setUyeKodu($uyeKodu = null)
    {
        // validation for constraint: string
        if (!is_null($uyeKodu) && !is_string($uyeKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uyeKodu)), __LINE__);
        }
        if (is_null($uyeKodu) || (is_array($uyeKodu) && empty($uyeKodu))) {
            unset($this->UyeKodu);
        } else {
            $this->UyeKodu = $uyeKodu;
        }
        return $this;
    }
    /**
     * Get adresId value
     * @return int|null
     */
    public function getAdresId()
    {
        return $this->adresId;
    }
    /**
     * Set adresId value
     * @param int $adresId
     * @return \StructType\SelectUyeAdres
     */
    public function setAdresId($adresId = null)
    {
        // validation for constraint: int
        if (!is_null($adresId) && !is_numeric($adresId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($adresId)), __LINE__);
        }
        $this->adresId = $adresId;
        return $this;
    }
    /**
     * Get uyeId value
     * @return int|null
     */
    public function getUyeId()
    {
        return $this->uyeId;
    }
    /**
     * Set uyeId value
     * @param int $uyeId
     * @return \StructType\SelectUyeAdres
     */
    public function setUyeId($uyeId = null)
    {
        // validation for constraint: int
        if (!is_null($uyeId) && !is_numeric($uyeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($uyeId)), __LINE__);
        }
        $this->uyeId = $uyeId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SelectUyeAdres
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
