<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UyeTuru StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:UyeTuru
 * @subpackage Structs
 */
class UyeTuru extends AbstractStructBase
{
    /**
     * The FiyatTuru
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FiyatTuru;
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Tanim
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tanim;
    /**
     * Constructor method for UyeTuru
     * @uses UyeTuru::setFiyatTuru()
     * @uses UyeTuru::setID()
     * @uses UyeTuru::setTanim()
     * @param string $fiyatTuru
     * @param int $iD
     * @param string $tanim
     */
    public function __construct($fiyatTuru = null, $iD = null, $tanim = null)
    {
        $this
            ->setFiyatTuru($fiyatTuru)
            ->setID($iD)
            ->setTanim($tanim);
    }
    /**
     * Get FiyatTuru value
     * @return string|null
     */
    public function getFiyatTuru()
    {
        return $this->FiyatTuru;
    }
    /**
     * Set FiyatTuru value
     * @uses \EnumType\FiyatTuru::valueIsValid()
     * @uses \EnumType\FiyatTuru::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $fiyatTuru
     * @return \StructType\UyeTuru
     */
    public function setFiyatTuru($fiyatTuru = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\FiyatTuru::valueIsValid($fiyatTuru)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $fiyatTuru, implode(', ', \EnumType\FiyatTuru::getValidValues())), __LINE__);
        }
        $this->FiyatTuru = $fiyatTuru;
        return $this;
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\UyeTuru
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Tanim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTanim()
    {
        return isset($this->Tanim) ? $this->Tanim : null;
    }
    /**
     * Set Tanim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tanim
     * @return \StructType\UyeTuru
     */
    public function setTanim($tanim = null)
    {
        // validation for constraint: string
        if (!is_null($tanim) && !is_string($tanim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tanim)), __LINE__);
        }
        if (is_null($tanim) || (is_array($tanim) && empty($tanim))) {
            unset($this->Tanim);
        } else {
            $this->Tanim = $tanim;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UyeTuru
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
